//programme partagé avec plaisir
//Fablab du Chalonnais
//juin 2018

/*================= Bibliotheque ==================*/
#include <avr/sleep.h>        //permet la mise en veille
#include <Wire.h>             //permet communication i2c pour l horloge ds3231
#include <DS3231.h>           //bibliotheque pour utiliser l horloge ds3231
#include <Stepper_28BYJ_48.h> //bibliotheque pour moteur pas a pas

/*================= Variable ======================*/
volatile byte compt = 0;            //valeur qui compte nbr interruption

byte capthaut = 10;          //capteur haut sur le pin 10
byte captbas = 11;           //capteur bas sur le pin 11
byte alimentation = 5;       //alimente le circuit uln2003 pin 5

volatile byte haut = 0;      //porte la valeur du capteur haut
volatile byte bas = 0;       //porte la valeur du capteur bas

byte mois = 0;               //porte le numero du mois pour lire tableau
byte jour = 0;               //porte la valeur du jour
byte mimois = 0;             //represente si on est a la moitier du mois
byte hal1 = 0;               //porte la valeur heure pour alarme1
byte hal2 = 0;               //porte la valeur heure pour alarme2
byte minal1 = 0;             //porte la valeur minute pour alarme1
byte minal2 = 0;             //porte la valeur minute pour alarme2

Stepper_28BYJ_48 moteurpap(9,8,7,6);   //declaration des pin pour le moteur

/*==========variable pour tester=========*/
byte truc = 0;
byte jkl = 0;                //porte valeur comparative
byte klm = 0;

/*=========== simplification ecriture =============*/
DS3231 clock;
RTCDateTime dt;
RTCAlarmTime al1;       //ecrire al1 au lieu de RTCAlarmTime
RTCAlarmTime al2;       //ecrire al2 au lieu de RTCAlarmTime

/*================= Tableau =======================*/
     //horaire des tableaux seulement a l heure d ete
byte reveilal1[12][2][2] {{{9,20},{9,10}},    /*janvier*/
                          {{9,05},{8,45}},    /*fevrier*/
                          {{8,20},{7,55}},    /*mars*/
                          {{7,20},{6,55}},    /*avril*/
                          {{6,25},{6,05}},    /*mai*/
                          {{5,50},{5,45}},    /*juin*/
                          {{5,50},{6,00}},    /*juillet*/
                          {{6,20},{6,40}},    /*aout*/
                          {{7,00},{7,20}},    /*septembre*/
                          {{7,40},{8,00}},    /*octobre*/
                          {{8,20},{8,40}},    /*novembre*/
                          {{9,00},{9,20}}};   /*decembre*/

byte endortal2[12][2][2] {{{18,35},{18,55}},  /*janvier*/
                          {{19,25},{19,40}},  /*fevrier*/
                          {{19,58},{20,25}},  /*mars*/
                          {{20,45},{21,05}},  /*avril*/
                          {{21,25},{21,45}},  /*mai*/
                          {{21,55},{22,00}},  /*juin*/
                          {{22,00},{21,50}},  /*juillet*/
                          {{21,30},{21,10}},  /*aout*/
                          {{20,40},{20,10}},  /*septembre*/
                          {{19,40},{19,10}},  /*octobre*/
                          {{18,40},{18,30}},  /*novembre*/
                          {{18,20},{18,10}}}; /*decembre*/



/*================= SSEETTUUPP ====================*/
void setup()
{
  Serial.begin(9600);     //vitesse et activation de la communication avec l ordinateur
  pinMode(2, INPUT_PULLUP);   //declaration du pin 2 comme entree pour les INT0

  pinMode(capthaut, INPUT_PULLUP);      //declaration de l etat des capteurs en entree
  pinMode(captbas, INPUT_PULLUP);       //declaration de l etat des capteurs en entree
  pinMode(alimentation, OUTPUT);   //declaration de la sortie
  
  clock.begin();     //commencement horloge
  compt = 0;         //compte le nombre d interruption mise a zero
  attachInterrupt(0, compteur, FALLING);
  
  clock.armAlarm1(false);  // initialise alarme
  clock.armAlarm2(false);  // initialise alarme
  clock.clearAlarm1();     // initialise alarme
  clock.clearAlarm2();     // initialise alarme
  //clock.setDateTime(2018, 1, 19, 13, 15, 20); // sert a remettre à l heure DS3231
  miseajour();
  delay(200);
  clock.enableOutput(false); //permet le fonctionnement des alarmes
  digitalWrite(alimentation, HIGH);       //allume l alimentation uln2003
}

/*================= reveil arduino ================*/
void compteur()
{
  compt = compt + 1;
}

/*================= veille arduino ===============*/
void endortoi()
{
  delay(200);
  digitalWrite(alimentation, LOW);            //eteind l alimentation uln2003
  delay(1000);
  clock.enableOutput(false);
  delay(1000);
  attachInterrupt(0, compteur, FALLING);    //active l'interruption INT0 de la broche 2
  // pour permettre a l alarme de reveiller arduino
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);    //mode de veille la plus économique en énergie
  sleep_enable();                         //active le bit sommeil dans le registre MCUCR
  sleep_mode();                           //ici arduino dort
  //reprise du programme après le reveil
  sleep_disable();                        //desactive le sommeil bref reveil arduino
  
  detachInterrupt(0);              //desactive l interruption INT0 de la broche2 pour
                                   //ne pas interrompre le cours normale du programme
  digitalWrite(alimentation, HIGH);       //allume l alimentation uln2003
  delay(200);
}

/*============= mise a jour alarme ===============*/
void miseajour()
{
  mois = dt.month - 1; //actualise le numero du mois pour le tableau
  if (dt.day <= 15)
  {
    mimois = 0;       //determine quel moitier de mois on est
  } 
  else
  {
    mimois = 1;      //determine quel moitier de mois on est
  }             
  
  hal1 = reveilal1[mois][mimois][0];  //lecture dans le tableau heure alarme1
  minal1 = reveilal1[mois][mimois][1];//lecture dans le tableau minute alarme1
  hal2 = endortal2[mois][mimois][0];  //lecture dans le tableau heure alarme2
  minal2 = endortal2[mois][mimois][1];//lecture dans le tableau minute alarme2
  
  clock.setAlarm1(0, hal1, minal1, 0, DS3231_MATCH_H_M_S); //mise a l heure alarme1
  clock.setAlarm2(0, hal2, minal2, DS3231_MATCH_H_M);      //mise a l heure alarme2
  delay(200);
}


/*============= mise a jour alarme ouverture ===============*/
void miseajourouverture()
{
  mois = dt.month - 1; //actualise le numero du mois pour le tableau
  if (dt.day <= 15)
  {
    mimois = 0;       //determine quel moitier de mois on est
  } 
  else
  {
    mimois = 1;      //determine quel moitier de mois on est
  }             
  
  hal1 = reveilal1[mois][mimois][0];  //lecture dans le tableau heure alarme1
  minal1 = reveilal1[mois][mimois][1];//lecture dans le tableau minute alarme1
  //hal2 = endortal2[mois][mimois][0];  //lecture dans le tableau heure alarme2
  //minal2 = endortal2[mois][mimois][1];//lecture dans le tableau minute alarme2
  
  clock.setAlarm1(0, hal1, minal1, 0, DS3231_MATCH_H_M_S); //mise a l heure alarme1
  //clock.setAlarm2(0, hal2, minal2, DS3231_MATCH_H_M);      //mise a l heure alarme2
  delay(200);
}

/*============= mise a jour alarme fermeture ===============*/
void miseajourfermeture()
{
  mois = dt.month - 1; //actualise le numero du mois pour le tableau
  if (dt.day <= 15)
  {
    mimois = 0;       //determine quel moitier de mois on est
  } 
  else
  {
    mimois = 1;      //determine quel moitier de mois on est
  }             
  
  //hal1 = reveilal1[mois][mimois][0];  //lecture dans le tableau heure alarme1
  //minal1 = reveilal1[mois][mimois][1];//lecture dans le tableau minute alarme1
  hal2 = endortal2[mois][mimois][0];  //lecture dans le tableau heure alarme2
  minal2 = endortal2[mois][mimois][1];//lecture dans le tableau minute alarme2
  
  //clock.setAlarm1(0, hal1, minal1, 0, DS3231_MATCH_H_M_S); //mise a l heure alarme1
  clock.setAlarm2(0, hal2, minal2, DS3231_MATCH_H_M);      //mise a l heure alarme2
  delay(200);
}


/*=================== monte ======================*/
void monte()
{
  
  do
  {
    moteurpap.step(1);
    bas = digitalRead(captbas);
    haut = digitalRead(capthaut);
  }  while (haut == 1);
  
  bas = 1;
}

/*=================== descend ====================*/
void descend()
{
  
  do
  {
    moteurpap.step(-1);
    bas = digitalRead(captbas);
    haut = digitalRead(capthaut);
    
  }  while (bas == 1);
  
  haut = 1;
}

/*================= LLOOOOPP =====================*/
void loop()
{
  dt = clock.getDateTime();        //lecture heure
  haut = digitalRead(capthaut);    //lecture capteur haut
  bas = digitalRead(captbas);      //lecture capteur bas

  //Serial.println(clock.dateFormat("d-m-Y H:i:s - l", dt));
  truc = clock.isOutput();
  //digitalWrite(alimentation, HIGH);       //allume l alimentation uln2003
  
  if ( haut == 1)
  {
    miseajourfermeture();
    delay(200);
    monte();
    
  }
  else if (bas == 1)
  {
    miseajourouverture();
    delay(200);
    descend();
    
  }

  endortoi();
  
  
}


